function [x1,x1d,x1dd,x1ddd,x1dddd,x2,x2d,x2dd,x2ddd,x2dddd,x3,x3d,x3dd,x3ddd,x3dddd] = TrajCercle(Pinitial,Pfinal,rayon,f,Tfin,t);

if (t > Tfin) t = Tfin; end;

PI = pi;
PI3 = pi^3;
PI4 = pi^4;
f3 = f^3;
f4 = f^4;
sin_aux = rayon*sin(2*f*PI*t);
cos_aux = rayon*cos(2*f*PI*t);

x1     = cos_aux ;
x1d    = -2 * f * PI * sin_aux;
x1dd   = -4 * sq(f) * sq(PI) * cos_aux;
x1ddd  =  8 * f3 * PI3 * sin_aux;         
x1dddd = 16 * f4 * PI4 * cos_aux * PI4;

x2     = sin_aux;
x2d    =  2 * f * PI * cos_aux;
x2dd   = -4 * sq(f) * sq(PI) * sin_aux;
x2ddd  = -8 * f3 * PI3 * cos_aux ;
x2dddd = 16 * f4 * PI4 * sin_aux;

t2 = t^2; t3 = t^3; t4 = t^4;
t5 = t^5; t6 = t^6; t7 = t^7;
t8 = t^8; t9 = t^9;

a5 = 126*(Pfinal(3) - Pinitial(3))/Tfin^5; 
a6 = 420*(Pinitial(3) - Pfinal(3))/Tfin^6;
a7 = 540*(Pfinal(3) - Pinitial(3))/Tfin^7;
a8 = 315*(Pinitial(3) - Pfinal(3))/Tfin^8;
a9 =  70*(Pfinal(3) - Pinitial(3))/Tfin^9; 

x3 = Pinitial(3) + a5*t5 + a6*t6 + a7*t7 + a8*t8 + a9*t9;
x3d = 5*a5*t4 + 6*a6*t5 + 7*a7*t6 + 8*a8*t7 + 9*a9*t8;
x3dd = 20*a5*t3 + 30*a6*t4 + 42*a7*t5 + 56*a8*t6 + 72*a9*t7;
x3ddd = 60*a5*t2 + 120*a6*t3 + 210*a7*t4 + 336*a8*t5 + 504*a9*t6;
x3dddd = 120*a5*t + 360*a6*t2 + 840*a7*t3 + 1680*a8*t4 + 3024*a9*t5;
