function der = dTlabvvx3der(t,T,flag,parameters)
n = length(T)/3; 

rho_tube = parameters(1);
rho_metal = parameters(2); 
rho_shell = parameters(3); 
cp_tube = parameters(4);
cp_metal = parameters(5);
cp_shell = parameters(6);
fc = parameters(7);
fh = parameters(8);
k_tube_metal = parameters(10);
k_metal_shell = parameters(11);
tcin = parameters(12);
thin = parameters(13);
A_tube_sec = parameters(14);
A_metal_sec = parameters(15);
V_tube_sec = parameters(16);
V_metal_sec = parameters(17);
V_shell_sec =parameters(18);


T = [tcin; T(1:n); thin; T(n+1:2*n); T(2*n+1:3*n)];

%Cold (shell)
aux1 = 1/(rho_shell*cp_shell*V_shell_sec);
aux2 = cp_shell*fc*rho_shell;
aux3 = k_metal_shell*A_metal_sec;

for i = 2:n+1,
   dT(i) = aux1*(aux2*(T(i-1)-T(i)) + aux3*(T(i+2*n+1)-T(i)));
end

%Hot (tube)
aux1 = 1/(rho_tube*cp_tube*V_tube_sec);
aux2 = cp_tube*fh*rho_tube;
aux3 = k_tube_metal*A_tube_sec;

for i = (n+3):2*n+2,
   dT(i) = aux1*(aux2*(T(i-1)-T(i)) - aux3*(T(i)-T(i+n)));
end

% Metal
aux1 = 1/(rho_metal*cp_metal*V_metal_sec);
aux2 = k_tube_metal*A_tube_sec;
aux3 = k_metal_shell*A_metal_sec;
for i = (2*n+3):(3*n+2),
   dT(i) = aux1*(aux2*(T(i-2*n-1)-T(i)) - aux3*(T(i)-T(i-n)));
end


der = [dT(2:n+1) dT(n+3:2*n+2) dT(2*n+3: 3*n+2)]';


