
parameters(1) = rho_tube;
parameters(2) = rho_metal;
parameters(3) = rho_shell;
parameters(4) = cp_tube; 			% J/kgC
parameters(5) = cp_metal; 			% J/kgC
parameters(6) = cp_shell; 			% J/kgC
parameters(7) = fc;  				% m3/s
parameters(8) = fh;  				% m3/s
parameters(10) = k_tube_metal;  	% W/m2Cs
parameters(11) = k_metal_shell;	% W/m2Cs
parameters(12) = tcin;				% C
parameters(13) = thin;				% C
parameters(14) = A_tube;   		%m2
parameters(15) = A_metal;   		%m2
parameters(16) = V_tube;   		%m3
parameters(17) = V_metal;   		%m3
parameters(18) = V_shell;   		%m3
parameters(19) = n;		   		%sections

if cocurrent, file = 'dTlabvvx3der';
else file = 'dTlabvvx2der';
end


if useoutput,
     [t,T] = ode23t(file,[0 tmax],T(nt,1:3*n),[],parameters);
else
     [t,T] = ode23t(file,[0 tmax],[linspace(initT,initT,n) linspace(initT,initT,n) linspace(initT,initT,n)],[],parameters);   
end

nt = length(t);

if cocurrent,
   tcin = T(nt,1);
   tcut = T(nt,n);
   thin = T(nt,n+1); 
   thut = T(nt,2*n);
else
   tcin = T(nt,n);
   tcut = T(nt,1);
   thin = T(nt,n+1);
   thut = T(nt,2*n);
end

parameters(12) = tcin;
parameters(13) = thin;

op = optimset('display','off','tolc',1e-8,'tolfun',1e-8);

dtlg = ((thin-T(nt,2*n+1))-(thut-T(nt,3*n)))/log((thin-T(nt,2*n+1))/(thut-T(nt,3*n)));

if cocurrent,
   %dtlg = ((thin-tcin)-(thut-tcut))/log((thin-tcin)/(thut-tcut));
   parameters(20) =((T(nt,2*n+1)-tcin)-(T(nt,3*n)-tcut))/log((T(nt,2*n+1)-tcin)/(T(nt,3*n)-tcut));
else
   % dtlg = ((thin-tcut)-(thut-tcin))/log((thin-tcut)/(thut-tcin));     
   parameters(20) = ((T(nt,2*n+1)-tcut)-(T(nt,3*n)-tcin))/log((T(nt,2*n+1)-tcut)/(T(nt,3*n)-tcin));
end

try
  % dtlg = fzero('itererat2',dtlg,op,parameters); 
  [temp, dtl, thutr, tcutr] = itererat2(dtlg,parameters); 
catch
  thutr = NaN;
  tcutr = NaN;   
end


%---------------------------------------------------------
% Variables for plotting the outlet temperatures

t_array = t';

if cocurrent,
	T1_cold_array = T(:,n)';
   T1_hot_array = T(:,2*n)';
else
   T1_cold_array = T(:,1)';
   T1_hot_array = T(:,2*n)';
end

% Variables for plotting the final temperature profiles

T2_cold_array = T(nt,1:n);
T2_hot_array = T(nt,n+1:2*n);
T2_metal_array = T(nt,2*n+1:3*n);

if ~cocurrent,
   T2_cold_array = T2_cold_array(length(T2_cold_array):-1:1);
   T2_metal_array = T2_metal_array(length(T2_metal_array):-1:1);
   T2_hot_array = T2_hot_array(length(T2_hot_array):-1:1);
end