%carga los parmetros del modelo
%clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%PARMETROS%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%CONDICIN INICIAL
ini.x0=2;
ini.y0=-0.01;
ini.th0=pi/2;

%PARMETROS FSICOS
hov.masa=0.894;%masa
hov.inercia=0.0125;%momento de inercia de rotacin
hov.r=0.05;%distancia motor/eje de simetra
hov.fdir=1*0.615;%fuerza de los motores en sentido directo
hov.finv=-1*0.3;%fuerza de los motores en sentido inverso
hov.rl=0.1;%c. rozamiento viscoso lineal
hov.rr=0.05;%c. rozamiento viscoso rotacional

%OTROS PARMETROS
hov.l=0.5;%longuitud del dibujo

%%%%%%%%%%%%%%%%%%%%%%%%%%%%TRAYECTORIA%%%%%%%%%%%%%%%%%%%%%%%%
%tipo de trayectoria
tra.tipo=1;%1=circulo 2=caso general
%tipo de problema
pro.tipo=2;%1=point stabilization, 2=tracking, 3=path following

%Para un crculo
tra.r=2.0;%radio
tra.v=1;%velocidad
N=1;%nmero de vueltas de aceleracin
w=tra.v/tra.r;
tra.a=w^2/(4*pi*N);%aceleracin angular (en la fase inicial)
beta=asin(hov.rl*w/sqrt(hov.masa*w^2+hov.rl^2));%angulo de desviacin de la direcin radial
tra.gamma=pi-beta;

%para una trayectoria general
archivo='tra1.mat';
s=load(archivo);
%interpolacin
tmax=max(s.t);
h=tmax/100;
tra.t=0:h:tmax;
tra.x=interp1(s.t,s.x,tra.t,'spline');
tra.y=interp1(s.t,s.y,tra.t,'spline');
tra.vx=diff(tra.x)/h;tra.vx(end+1)=tra.vx(end);
tra.ax=diff(tra.vx)/h;tra.ax(end+1)=tra.ax(end);
tra.vy=diff(tra.y)/h;tra.vy(end+1)=tra.vy(end);
tra.ay=diff(tra.vy)/h;tra.ay(end+1)=tra.ay(end);
tra.T=s.T;

%para estabilizacin en un punto
tra.rx=0;
tra.ry=0;
tra.rth=0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5CONTROLADOR%%%%%%%%%%%%%%%%%%%%%%
pid.kp1=0.4;
pid.ki1=0;
pid.kd1=2;
pid.N1=10;
pid.kp2=9.8;
pid.ki2=0;
pid.kd2=0;
pid.N2=10;

%open hov.mdl
